// FILENAME:	HercRace.cs
// 12:01 AM 7/24/99
// AUTHORS:  	Orogogus
//------------------------------------------------------------------------------

$missionName = "HercRace";

exec("multiplayerStdLib.cs");
//exec("GoadScore.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}


Pilot Pacer
{
   id = 28;
   
   skill = 0.8;
   accuracy = 0.8;
   aggressiveness = 0.4;
   activateDist = 2000.0;
   deactivateBuff = 3000.0;
   targetFreq = 4.0;
   trackFreq = 0.1;
   fireFreq = 0.1;
   LOSFreq = 0.4;
   name = "Pacer";
};


function onMissionStart()
{
	marsSounds();
}


function onMissionLoad(){
   cdAudioCycle("Purge", "Terror", "Watching"); 
}


function setDefaultMissionItems() 
{
	exec("defaultVehicles");
	allowComponent("all", true);
	allowWeapon("all", true);
}


function vehicle::onAdd(%vehicle)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicle);
    if(%player == 0) return;
	%player.name = getHUDName(%vehicle);
	%player.vehicle = getVehicleName(%vehicle);
	adjustScore(%player, %player.vehicle);

	say(%player, 0, "Modifiers for driving "@%player.vehicle @ "s:");
	say(%player, 0, %player.killMultiplier @ " points for a kill.");
	say(%player, 0, %player.lapMultiplier @ " points for crossing an 80m trigger.");

	%player.goal = 1;
	%player.points = 0;
	%player.oneLap = 0;
}

function vehicle::onDestroyed( %victimVeh, %destroyerVeh )
{

	if( getTeam( %destroyerVeh ) != *IDSTR_TEAM_PURPLE )
	{
		%player = playerManager::vehicleIdToPlayerNum(%destroyerVeh);
		for(%i=0; %i<%player.killMultiplier; %i++)
		{
			%player.points++;
		}

		say(%player, 0, "A kill!");
		say(%player, 0, %player.points @ " points!");		
	}
}

function onMissionStart()
{
	setRacer();
}


function setRacer()
{

	$paths1 = getObjectId("MissionGroup/Path");

	%herc = NewObject("GoadMole", Herc, 21 ); 
	setTeam( %herc, *IDSTR_TEAM_PURPLE );
	setPilotId(%herc,28);
	setPosition( %herc, 185, -510, 100);
	order( %herc, guard, $paths1);

}


//========================



function Score1::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 1)
	{
		triggerScore(%player);

		if(%player.oneLap == 1)
		{
			%temp = getCurrentTime();
			%timeString = timeDifference(%temp, %player.lapTime);
			say(%player, 0, "Lap completed in " @ %timeString);
			%player.lapTime = getCurrentTime();
			setHudTimer(0, 0, "", 2, %player);
			setHudTimer(25000, 1, "Lap Time", 2, %player);

			healObject( %vehicleId, 50000);
			healObject( %vehicleId, 50000);
			reloadObject(%vehicleId, 100);
			healObject( %vehicleId, 50000);
		}

		if(%player.oneLap == 0)
		{
			%player.oneLap = 1;

			%player.lapTime = getCurrentTime();
			setHudTimer(25000, 1, "Lap Time", 2, %player);
			%player.startTime = getCurrentTime();
			setHudTimer(25000, 1, "Total Time", 1, %player);
		}
	}

}

function Score2::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 2)
	{
		triggerScore(%player);
	}
}

function Score3::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 3)
	{
		triggerScore(%player);
	}
}

function Score4::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 4)
	{
		triggerScore(%player);
	}
}

function Score5::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 5)
	{
		triggerScore(%player);
	}
}

function Score6::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 6)
	{
		triggerScore(%player);
	}
}

function Score7::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 7)
	{
		triggerScore(%player);
	}
}

function Score8::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 8)
	{
		triggerScore(%player);
	}
}

function Score9::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 9)
	{
		triggerScore(%player);
	}
}

function Score10::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 10)
	{
		triggerScore(%player);
	}
}

function Score11::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 11)
	{
		triggerScore(%player);
	}
}


function Score12::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 12)
	{
		triggerScore(%player);
	}
}

function Score13::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 13)
	{
		triggerScore(%player);
	}
}

function Score14::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 14)
	{
		triggerScore(%player);
	}
}

function Score15::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 15)
	{
		triggerScore(%player);
	}
}

function Score16::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 16)
	{
		triggerScore(%player);
	}
}

function Score17::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 17)
	{
		triggerScore(%player);
	}
}

function Score18::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 18)
	{
		triggerScore(%player);
	}
}

function Score19::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 19)
	{
		triggerScore(%player);
	}
}

function Score20::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 20)
	{
		triggerScore(%player);
	}
}

function Score21::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 21)
	{
		triggerScore(%player);
	}
}

function Score22::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 22)
	{
		triggerScore(%player);
	}
}

function Score23::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 23)
	{
		triggerScore(%player);
	}
}

function Score24::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 24)
	{
		triggerScore(%player);
	}
}

function Score25::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 25)
	{
		triggerScore(%player);
	}
}

function Score26::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 26)
	{
		triggerScore(%player);
	}
}

function Score27::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 27)
	{
		triggerScore(%player);
	}
}

function Score28::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 28)
	{
		triggerScore(%player);
	}
}

function Score29::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 29)
	{
		triggerScore(%player);
	}
}

function Score30::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 30)
	{
		triggerScore(%player);
	}
}

function Score31::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	if(%player.goal == 31)
	{
		triggerScore(%player);
	}
}

//===============

function triggerScore(%player)
{
	if(%player.goal == 31)
	{
		%player.goal = 1; 
	}
	else
	{
		%player.goal++;
	}

	for(%i=0; %i<%player.lapMultiplier; %i++)
	{
	%player.points++;
	}
	say(%player, 0, %player.points @ " points!");
}



//===============


function adjustScore(%player, %vehicle)
{

	if(%vehicle == "Apocalypse")
	{
		%player.killMultiplier = 2;
		%player.lapMultiplier = 4;
	}

	else if(%vehicle == "Basilisk")
	{
		%player.killMultiplier = 2;
		%player.lapMultiplier = 4;
	}

	else if(%vehicle == "Knight's Basilisk")
	{
		%player.killMultiplier = 2;
		%player.lapMultiplier = 4;
	}

	else if(%vehicle == "Emancipator")
	{
		%player.killMultiplier = 3;
		%player.lapMultiplier = 3;
	}

	else if(%vehicle == "Gorgon")
	{
		%player.killMultiplier = 1;
		%player.lapMultiplier = 5;
	}

	else if(%vehicle == "Knight's Gorgon")
	{
		%player.killMultiplier = 1;
		%player.lapMultiplier = 5;
	}

	else if(%vehicle == "Minotaur")
	{
		%player.killMultiplier = 3;
		%player.lapMultiplier = 3;
	}

	else if(%vehicle == "Olympian")
	{
		%player.killMultiplier = 1;
		%player.lapMultiplier = 5;
	}

	else if(%vehicle == "Talon")
	{
		%player.killMultiplier = 5;
		%player.lapMultiplier = 1;
	}


	else if(%vehicle == "Knight's Talon")
	{
		%player.killMultiplier = 5;
		%player.lapMultiplier = 1;
	}


	else if(%vehicle == "Adjudicator")
	{
		%player.killMultiplier = 2;
		%player.lapMultiplier = 4;
	}

	else if(%vehicle == "Platinum Guard Adjudicator")
	{
		%player.killMultiplier = 2;
		%player.lapMultiplier = 4;
	}

	else if(%vehicle == "Executioner")
	{
		%player.killMultiplier = 1;
		%player.lapMultiplier = 5;
	}

	else if(%vehicle == "Platinum Guard Executioner")
	{
		%player.killMultiplier = 1;
		%player.lapMultiplier = 5;
	}

	else if(%vehicle == "Goad")
	{
		%player.killMultiplier = 3;
		%player.lapMultiplier = 3;
	}

	else if(%vehicle == "Shepherd")
	{
		%player.killMultiplier = 3;
		%player.lapMultiplier = 3;
	}

	else if(%vehicle == "Seeker")
	{
		%player.killMultiplier = 5;
		%player.lapMultiplier = 1;
	}

	else if(%vehicle == "Disrupter")
	{
		%player.killMultiplier = 0;
		%player.lapMultiplier = 0;
	}

	else if(%vehicle == "Predator")
	{
		%player.killMultiplier = 2;
		%player.lapMultiplier = 2;
	}

	else if(%vehicle == "Myrmidon")
	{
		%player.killMultiplier = 2;
		%player.lapMultiplier = 5;
	}

	else
	{
		%player.killMultiplier = 3;
		%player.lapMultiplier = 3;
	}

}


//================


